# THIS FILE IS AUTOMATICALLY GENERATED BY CARGO
#
# When uploading crates to the registry Cargo will automatically
# "normalize" Cargo.toml files for maximal compatibility
# with all versions of Cargo and also rewrite `path` dependencies
# to registry (e.g., crates.io) dependencies.
#
# If you are reading this file be aware that the original Cargo.toml
# will likely look very different (and much more reasonable).
# See Cargo.toml.orig for the original contents.

[package]
edition = "2024"
name = "frakti"
version = "0.1.4"
authors = [
    "Ayrat Badykov <ayratin555@gmail.com>",
    "EdJoPaTo <frankenstein-rust@edjopato.de>",
    "Pepe Márquez <pepe.marquezromero@gmail.com>",
    "PRO-2684",
]
build = false
autolib = false
autobins = false
autoexamples = false
autotests = false
autobenches = false
description = "Telegram bot API client for Rust, with a focus on single-threaded async runtime support"
readme = "README.md"
keywords = [
    "request",
    "http",
    "client",
    "bot",
    "telegram",
]
categories = ["web-programming::http-client"]
license = "WTFPL"
repository = "https://github.com/PRO-2684/frakti"

[package.metadata.docs.rs]
all-features = true

[features]
client-cyper = [
    "trait-async",
    "dep:cyper",
    "dep:compio",
    "dep:serde_json",
]
trait-async = []

[lib]
name = "frakti"
path = "src/lib.rs"

[[example]]
name = "async_custom_client"
path = "examples/async_custom_client.rs"
required-features = ["client-cyper"]

[[example]]
name = "async_file_upload"
path = "examples/async_file_upload.rs"
required-features = ["client-cyper"]

[[example]]
name = "async_get_me"
path = "examples/async_get_me.rs"
required-features = ["client-cyper"]

[[example]]
name = "async_reply_to_message_updates"
path = "examples/async_reply_to_message_updates.rs"
required-features = ["client-cyper"]

[dependencies.bon]
version = "3.9.1"

[dependencies.compio]
version = "0.19.0-rc.2"
features = ["fs"]
optional = true
default-features = false

[dependencies.cyper]
version = "0.9.0-rc.3"
features = [
    "json",
    "multipart",
]
optional = true

[dependencies.macro_rules_attribute]
version = "0.2.2"

[dependencies.paste]
version = "1.0.15"

[dependencies.serde]
version = "1.0.228"
features = ["derive"]

[dependencies.serde_json]
version = "1.0.150"
optional = true

[dependencies.serde_with]
version = "3.20.0"
features = ["macros"]
default-features = false

[dependencies.thiserror]
version = "2"

[dev-dependencies.compio]
version = "0.19.0-rc.2"
features = ["macros"]
default-features = false

[dev-dependencies.serde_json]
version = "1"

[lints.clippy]
missing_errors_doc = "allow"
unreadable_literal = "allow"

[lints.clippy.nursery]
level = "warn"
priority = -1

[lints.clippy.pedantic]
level = "warn"
priority = -1

[lints.rust]
unsafe_code = "forbid"
